/***************************************************************************
 *   Copyright (C) 2004 by Cyril Bosselut                                  *
 *   bosselut@b1project.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qfileinfo.h>

#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>
#include <kdebug.h>
#include <dcopref.h>
#include <dcopclient.h>

#include "ktagmainwin.h"

static const char description[] =
    I18N_NOOP("A KDE audio tag editor");

static const char version[] = "0.2.1";

static KCmdLineOptions options[] =
{
    { "s", 0, 0 },{ "setup", I18N_NOOP("Configure Ktag."), 0 }, { "+[URL]", I18N_NOOP( "Document to open." ), 0 }, KCmdLineLastOption
};

int main(int argc, char **argv)
{
    KAboutData about("ktag", I18N_NOOP("Ktag"), version, description, KAboutData::License_GPL, "(C) 2004 Cyril Bosselut", 0, 0, "bosselut@b1project.com");
    about.addAuthor( "Cyril Bosselut", 0, "bosselut@b1project.com" );
    about.setTranslator(I18N_NOOP("INSERT YOUR NAME HERE"),I18N_NOOP("INSERT YOUR EMAIL ADDRESS"));
    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions( options );
    KUniqueApplication::addCmdLineOptions();
    if (!KUniqueApplication::start()) {
	kdDebug("Main")<< "myAppName is already running!" << endl;
        KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
    	DCOPClient *client= new DCOPClient();
	if (!client->isAttached()){
		client->attach();
	}
	if(args->count() > 0){
		for (int i = 0; i < (args->count()); i++){
			kdDebug("Main")<< args->arg(i) << endl;
			DCOPRef m_ktagKTag("ktag","KTag");
			m_ktagKTag.call("openFile(QString)", QFileInfo(args->arg(i)).absFilePath()).isValid();
		}

	}
    }
    else{
	KUniqueApplication* app = new KUniqueApplication();
	// no session.. just start up normally
	app->disableSessionManagement();
	KSimpleConfig conf("ktagrc",false);
	if(!conf.hasGroup("ktag")){
		conf.setGroup("ktag");
		conf.writeEntry("patterns", "http://img.darktown.com/cover/audio/download/%l/%artist_-_%album_a.jpg,http://img.darktown.com/cover/audio/download/%l/%artist_%album_a.jpg,http://img.darktown.com/cover/audio/download/%l/%Artist_%Album_a.jpg");
		conf.sync();
	}
	KTagMainWin *mainWin;
	
		KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
	
	
		mainWin = new KTagMainWin(NULL, "KTagMainWin");
		app->setMainWidget( mainWin );
		if(args->isSet("setup")){
			mainWin->config();
			exit(0);
		}
		if(args->count() > 0){
			for (int i = 0; i < (args->count()); i++){
				kdDebug("Main")<< args->arg(i) << endl;
				mainWin->openFile(QFileInfo(args->arg(i)).absFilePath());
			}
		}
		else{
			if( !mainWin->chooseFile()){
				exit(0);
			}
		}
		mainWin->show();
	
		args->clear();
	
	// mainWin has WDestructiveClose flag by default, so it will delete itself.
	return app->exec();
    }
}

